#!/usr/bin/perl
# 
# log converter for JUGEM
# == scripted by SimpleBoxes 2004 =====

{ # 
	use strict;
	use vars qw($gVersion_ %gEnv $gEncode @gIn %gIn);
	use lib qw(. ../lib ../ext);
	require 'sbtext.pl';
	require 'sbform.pl';
	require Jcode;
	$gEncode = \&Jcode::convert;
	$gEnv{'basic'}{'max_data'} = 2048000;
	$gVersion_ = '0.01';
}
{ # ᥤ󥹥ץ
	&sbform_read();
	if ($gIn{'mtlog'}) {
		&main($gIn{'mtlog'});
	} else {
		&entrance();
	}
}
exit(0);

sub entrance {
	my $cgi = 'mtlog2xml.cgi';
	print 'Content-type: text/html;charset=EUC-JP',"\n\n"; # http head
	print <<"_HTML_";
<?xml version=\"1.0\" encoding=\"EUC-JP\"?>
<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\" lang=\"ja\">
<head>
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<link rel="stylesheet" type="text/css" href="style.css" title="default" media="screen,tv" />
	<title>Ѵץ</title>
</head>
<body>
<h1><a href=\"../index.html\"><img src=\"title.gif\" width=\"700\" height=\"50\" alt=\"sb - Development Laboratory\" title=\"sb - Development Laboratory\" /></a></h1>
<form class=\"single\" action=\"$cgi\" method=\"post\" enctype=\"multipart/form-data\">
<h2>MovableType Log Text \&rArr; JUGEM Simple XML</h2>
<dl>
	<dt><label for=\"mtlog\" accesskey=\"f\" title=\"MovableTypeǽϤեꤷޤ\">log file</label></dt>
	<dd><input type=\"file\" name=\"mtlog\" id=\"mtlog\" value=\"\" size=\"50\" /></dd>
	<dt><label for=\"blogname\" accesskey=\"b\" title=\"֥̾ΤϤޤ\">weblog name</label></dt>
	<dd><input type=\"text\" name=\"blogname\" id=\"blogname\" value=\"\" size=\"40\" /></dd>
	<dt><label for=\"description\" accesskey=\"d\" title=\"֥Ϥޤ\">description</label></dt>
	<dd><textarea name=\"description\" id=\"description\" rows=\"5\" cols=\"40\"></textarea></dd>
	<dt class=\"submit\"><label for=\"submit\">submit</label></dt>
	<dd class=\"submit\"><input type=\"submit\" name=\"submit\" id=\"submit\" value=\"submit\" /></dd>
</dl>
<p class=\"note\">Movable TypeΡ֥ȥ꡼񤭽Ф׵ǽǽϤJUGEMǥݡȤƤSimple XMLѴޤXMLΤޤ޽ϤΤǡ̾¸פʤɤѤơȤΥѥˡ.xmlפȤĥҤ¸ƤѴˤϻ֤礬ޤ</p>
<p class=\"link\">[<a href=\"xml2mtlog.cgi\">xml2mtlog</a>]</p>
</form>
<address>Copyright \&copy; SimpleBoxes 2004. All rights reserved. \[ver. $gVersion_\]</address>
<address>Provided by <a href=\"http://paperboy.co.jp\" target=\"_blank\">paperboy\&amp;co.</a></address>
</body>
</html>
_HTML_
	return();
}
sub main {
	my $text = shift;
	my $aLogSep = ('-' x 8);
	my $aSubSep = ('-' x 5);
	eval { # ᥤ롼
		{ # 󥳡ɽ
			$text =~ s/\x0D\x0A/\n/g;
			$text =~ tr/\x0D\x0A/\n\n/;
			&$gEncode(\$text,'utf8');
		}
		my $body = '';
		my @user = ();
		foreach my $entry (split("\n$aLogSep\n",$text)) { # ȥ꡼
			next if (!$entry);
			my %elem = ();
			my ($meta,@elements) = split(/^$aSubSep/m,$entry);
			my ($comnum,$tb_num) = (0,0);
			foreach my $line (split("\n",$meta)) {
				next if(!$line);
				$line =~ s/^\s*//;
				$line =~ s/\s*$//;
				my ($key,$val) = split(/\s*:\s*/,$line,2);
				if ($key eq 'AUTHOR') {
					push(@user,$val);
					$elem{'author'} = $val;
				} elsif ($key eq 'PRIMARY CATEGORY') {
					$elem{'category'} = $val;
				} elsif ($key eq 'TITLE') {
					$elem{'title'} = $val;
				} elsif ($key eq 'DATE') {
					$elem{'date'} = &sbmt_logDateConv($val);
				} elsif ($key eq 'STATUS') {
					$elem{'status'} = $val;
				} elsif ($key eq 'ALLOW COMMENTS') {
					$elem{'alcom'} = $val;
				} elsif ($key eq 'ALLOW PINGS') {
					$elem{'alping'} = $val;
				} elsif ($key eq 'CONVERT BREAKS') {
					$elem{'format'} = $val;
				}
			}
			foreach my $element (@elements) {
				$element =~ s/^\s*//;
				$element =~ s/\s*$//;
				if ($element =~ s/^BODY:\n//) {
					$elem{'body'} = $element;
				} elsif ($element =~ s/^EXTENDED BODY:\n//) {
					$elem{'sequel'} = $element;
				} elsif ($element =~ s/^EXCERPT:\n//) {
					$elem{'excerpt'} = $element;
				} elsif ($element =~ s/^KEYWORDS:\n//) {
					$elem{'keyword'} = $element;
				} elsif ($element =~ s/^COMMENT:\n//) {
					$elem{'com'} = [] if (!$comnum);
					$elem{'com'}[$comnum] = {};
					my @lines = split("\n",$element);
					my ($i,$idx) = (0,0);
					READ_COM: foreach my $line (@lines) {
						$line =~ s/^\s*//;
						my ($key,$val) = split(/\s*:\s*/,$line,2);
						if ($key eq 'AUTHOR') {
							$elem{'com'}[$comnum]{'name'} = $val;
						} elsif ($key eq 'EMAIL') {
							$elem{'com'}[$comnum]{'mail'} = $val;
						} elsif ($key eq 'URL') {
							$elem{'com'}[$comnum]{'link'} = $val;
						} elsif ($key eq 'IP') {
							$elem{'com'}[$comnum]{'host'} = $val;
						} elsif ($key eq 'DATE') {
							$elem{'com'}[$comnum]{'date'} = &sbmt_logDateConv($val);
						} else {
							$idx = $i;
							last READ_COM;
						}
						$i++;
					}
					$elem{'com'}[$comnum]{'body'} = join("<br />\n", @lines[$idx..$#lines]);
					$comnum++;
				} elsif ($element =~ s/^PING:\n//) {
					$elem{'tb'} = [] if (!$tb_num);
					$elem{'tb'}[$tb_num] = {};
					my @lines = split("\n",$element);
					my ($i,$idx) = (0,0);
					READ_TB: foreach my $line (@lines) {
						$line =~ s/^\s*//;
						my ($key,$val) = split(/\s*:\s*/,$line,2);
						if ($key eq 'TITLE') {
							$elem{'tb'}[$tb_num]{'subj'} = $val;
						} elsif ($key eq 'URL') {
							$elem{'tb'}[$tb_num]{'link'} = $val;
						} elsif ($key eq 'IP') {
							$elem{'tb'}[$tb_num]{'host'} = $val;
						} elsif ($key eq 'BLOG NAME') {
							$elem{'tb'}[$tb_num]{'name'} = $val;
						} elsif ($key eq 'DATE') {
							$elem{'tb'}[$tb_num]{'date'} = &sbmt_logDateConv($val);
						} else {
							$idx = $i;
							last READ_TB;
						}
						$i++;
					}
					$elem{'tb'}[$tb_num]{'body'} = join("\n", @lines[$idx..$#lines]);
					$tb_num++;
				}
			}
			$body .= &sbmt_entry(\%elem,$comnum,$tb_num);
		}
		print 'Content-type: application/xml;charset=utf-8',"\n\n";
		print &sbmt_head($gIn{'blogname'},$gIn{'description'},\@user);
		print $body;
		print &sbmt_foot();
	};
	&error($@) if ($@);
	return();
}
sub sbmt_entry {
	my ($hash,$com,$tb) = @_;
	my $output = '';
	my %entry = %$hash;
	$output .= <<"_XML_ENTRY_";
	<entry>
		<title>$entry{'title'}</title>
		<author>$entry{'author'}</author>
		<category>$entry{'category'}</category>
		<status>$entry{'status'}</status>
		<allowcomments>$entry{'alcom'}</allowcomments>
		<allowpings>$entry{'alping'}</allowpings>
		<convertbreaks>$entry{'format'}</convertbreaks>
		<date>$entry{'date'}</date>
		<excerpt>$entry{'excerpt'}</excerpt>
		<keyword>$entry{'keyword'}</keyword>
		<description><!\[CDATA\[$entry{'body'}\]\]></description>
		<sequel><!\[CDATA\[$entry{'sequel'}\]\]></sequel>
_XML_ENTRY_
	$output .= "\t\t" . '<comments>' . "\n";
	for (my $i=0;$i<$com;$i++) {
		$output .= <<"_XML_COMMENT_";
			<comment>
				<title />
				<description><!\[CDATA\[$entry{'com'}[$i]{'body'}\]\]></description>
				<name>$entry{'com'}[$i]{'name'}</name>
				<email>$entry{'com'}[$i]{'mail'}</email>
				<url>$entry{'com'}[$i]{'link'}</url>
				<host>$entry{'com'}[$i]{'host'}</host>
				<date>$entry{'com'}[$i]{'date'}</date>
			</comment>
_XML_COMMENT_
	}
	$output .= "\t\t" . '</comments>' . "\n";
	$output .= "\t\t" . '<trackbacks>' . "\n";
	for (my $i=0;$i<$tb;$i++) {
		$output .= <<"_XML_TRACKBACK_";
			<trackback>
				<title>$entry{'tb'}[$i]{'subj'}</title>
				<excerpt><!\[CDATA\[$entry{'tb'}[$i]{'body'}\]\]></excerpt>
				<blog_name>$entry{'tb'}[$i]{'name'}</blog_name>
				<host>$entry{'tb'}[$i]{'host'}</host>
				<url>$entry{'tb'}[$i]{'link'}</url> 
				<date>$entry{'tb'}[$i]{'date'}</date> 
			</trackback>
_XML_TRACKBACK_
	}
	$output .= "\t\t" . '</trackbacks>' . "\n";
	$output .= "\t" . '</entry>' . "\n";
	return($output);
}
sub error {
	my $text = shift;
	print 'Content-type: text/html;charset=EUC-JP',"\n\n"; # http head
	print <<"_HTML_";
<?xml version=\"1.0\" encoding=\"EUC-JP\"?>
<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\" lang=\"ja\">
<head>
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\" />
	<title>error</title>
</head>
<body>
<h1>error</h1>
<p>$text</p>
</body>
</html>
_HTML_
	exit(0);
}
sub sbmt_head {
	my ($blog,$text,$array) = @_;
	my $output = '';
	my @users = @$array;
	{ # 󥳡ɽ
		$blog = &sbtxt_uridec($blog);
		$text = &sbtxt_uridec($text);
		$text =~ s/\x0D\x0A/\n/g;
		$text =~ tr/\x0D\x0A/\n\n/;
		&$gEncode(\$text,'utf8');
	}
	$output .= <<"_XML_HEAD_";
<?xml version=\"1.0\" encoding=\"utf-8\"?>
<blog>
	<name>$blog</name> 
	<description><!\[CDATA\[$text\]\]></description>
_XML_HEAD_
	my %count;
	@users = grep(!$count{$_}++, @users);
	$output .= "\t" . '<users>' . "\n" if ($#users > -1);
	foreach my $user (@users) {
		$output .= <<"_XML_USER_";
		<user>
			<name>$user</name> 
			<full_name>$user</full_name> 
			<description></description> 
		</user>
_XML_USER_
	}
	$output .= "\t" . '</users>' . "\n" if ($#users > -1);
	$output .= "\t" . '<entries>' . "\n";
	return($output);
}
sub sbmt_foot {
	my $output = <<"_XML_FOOT_";
	</entries>
</blog>
_XML_FOOT_
	return($output);
}
sub sbmt_logDateConv {
	my $text = shift;
	if ($text =~ /(\d\d)\/(\d\d)\/(\d\d\d\d) (\d\d)\:(\d\d\:\d\d) (\w\w)/) {
		my $ho = $4;
		my $mm = $6;
		$ho += 12 if ($mm eq 'PM' and $ho < 12);
		return($3 . '/' . $1 . '/' . $2 . ' ' . $ho . ':' . $5);
	}
	return($text);
}
